# Examples

The following is an incomplete list of official and unofficial projects and samples highlighting and showcasing functionality offered by Quorum platform. [quorum-examples](https://github.com/jpmorganchase/quorum-examples.git), is the official sample repository and it provides the means to easily create pre-configured networks for testing/development.

Current examples include:

* [7nodes](https://github.com/jpmorganchase/quorum-examples.git): Starts up a fully-functioning Quorum environment consisting of 7 independent nodes. This example demonstrates consensus, privacy, and all the expected functionality of an Ethereum platform.
* [5nodesRTGS](https://github.com/bacen/quorum-examples/tree/master/examples/5nodesRTGS): Starts up a set of 5 nodes that simulates a Real-time Gross Settlement environment with 3 banks, one regulator (typically a central bank) and an observer that cannot access the private data.
* [consistency-checker](https://github.com/miguelmartinezinf/consistency-checker): Consistency-checker enhances trust between parties involved in private smart contracts. This tool acts as an oracle, listening to modifications of a specific private contract on every participant node and publishing the unique state of the contract at every block height on a public contract.
* [web3j token sample](https://github.com/blk-io/quorum-sample): This project demonstrates the creation and management of a private token on a Quorum network. Quorum privacy is used, only certain members of the network are privy to the token that has been created. It is written in Java using web3j which is maintained by Web3 Labs.
* Pons [backend](https://github.com/M-Bowe/pons) | [frontend](https://github.com/M-Bowe/pons-frontend): A sample Cross-Chain Trading Bridge written to run over 2 Quorum Chains to safely exchange ERC-20 and ERC-721 assets.
* [Marketplace](https://github.com/lyotam/techmarketplace): Marketplace is an example application running on top of a Quorum network which allows users to bid for and offer virtual hackathon gear for sale in an interactive marketplace. This app is based on what was originally developed for the MLH Localhost Quorum workshop, which demonstrates how to run a simple Ethereum application and how to write a simple Smart Contract that interacts with the Ethereum-based network.


!!! Info
    Most of the links link out to externally maintained repos. We thank all of the authors. Please contact us for any modifications or questions about the content.
